EDIT - bug #9556

occurrence/{uuid}/fieldUnitDTOs web service adds duplicate units to response
03/25/2021 05:52 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.22

Severity: critical Found in Version:

Description

see http://localhost:8080/occurrence/8585081¢-b73b-440b-b349-582845¢f3fb4/fieldUnitDTOs.json

the response data may be filtered with

http http://localhost:8080/occurrence/8585081c-b73b-440b-b349-582845cf3fb4/fieldUnitDTOs. json | Jg
'.'" | grep 'XKCD MASKS 2X (Masks)'

to see duplicates easily

Related issues:
Related to EDIT - bug #9557: implement occurrence/{uuid}/rootUnitDTOs Closed
Related to EDIT - task #9253: revise OccurrenceServicelmpl.findFieldUnitDTO(..) Closed

Associated revisions

Revision 3309605f - 03/26/2021 03:55 PM - Andreas Kohlbecker
ref #9556 DerivedUnitFacadeController.doGetFieldObjectMediaDTO() is no longer using loadFieldUnitDTO

Revision 5446c6d5 - 03/29/2021 10:45 AM - Katja Luther

ref #9556: remove derivates from fieldUnitDto in loadFieldUnitDto

Revision 6d3c3fa9 - 04/13/2021 01:54 PM - Andreas Kohlbecker

ref #9556 avoiding collection of full derivatives tree in DTOs

Revision cc1886a6 - 04/14/2021 01:28 PM - Andreas Kohlbecker

ref #9556 avoiding collection of full derivatives tree in DTOs - bugfix

Revision ce564745 - 04/14/2021 05:04 PM - Andreas Kohlbecker

ref #9556 avoiding collection of full derivatives tree in DTOs - using maxdepth parameter

History

#2 - 03/26/2021 11:59 AM - Andreas Kohlbecker
- Related to bug #9557 implement occurrence/{uuid}/rootUnitDTOs added

#3 - 03/26/2021 12:16 PM - Andreas Kohlbecker

This method is kind of misused: After solving #9557 it is only being used by .DerivedUnitFacadeController.doGetFieldObjectMediaDTO() which again
is used by the data portal to retrieve the FieldUnit Media.

e First of all this method adds an extra overhead by creating DTOs for all intermediate units which are not being used at all.
¢ Secondly does this method not deliver media of all FieldUnits, only for the first one that is found, see #9253

#4 - 03/26/2021 12:16 PM - Andreas Kohlbecker
- Related to task #9253: revise OccurrenceServicelmpl.findFieldUnitDTO(..) added

#5 - 03/26/2021 12:17 PM - Andreas Kohlbecker
- Related to task #9430: revise OccurrenceServicelmpl._findRootUnitDTO(..) supports multiple origin paths added
http://localhost:8080/occurrence/8585081c-b73b-440b-b349-582845cf3fb4/fieldUnitDTOs.json
#6 - 03/26/2021 02:21 PM - Andreas Kohlbecker
- Related to deleted (task #9430: revise OccurrenceServicelmpl._findRootUnitDTO(..) supports multiple origin paths)

#7 - 03/26/2021 02:26 PM - Andreas Kohlbecker
- Status changed from New to Rejected

- Target version deleted (Release 5.22)

since the intermediate units are not used at all by consuming methods, they should be skipped completely.

#8 - 03/26/2021 02:32 PM - Andreas Kohlbecker

- Status changed from Rejected to Feedback

- Assignee changed from Andreas Kohlbecker to Katja Luther

- Target version set to Release 5.22

reopening this issue since loadFieldUnitDTO() is being used in the Taxeditor
@Katja: are the derivatives of the FieldUnitDTO being used in the TaxEditor?

#9 - 03/26/2021 03:57 PM - Andreas Kohlbecker

- Category changed from cdmlib-remote to cdmlib

DerivedUnitFacadeController.doGetFieldObjectMediaDTO() is no longer using loadFieldUnitDTO see 3309605f
therefore the Taxeditor is the only component which is using this method.

#10 - 03/26/2021 04:07 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Kohlbecker

Andreas Kohlbecker wrote:
reopening this issue since loadFieldUnitDTO() is being used in the Taxeditor

@Katja: are the derivatives of the FieldUnitDTO being used in the TaxEditor?

no, the derivatives are not used in the editor

#11 - 03/26/2021 04:19 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Katja Luther

so we should modify this service method so that it no longer add the derivatives or is there an alternative service method that can be used instead. In
the latter case loadFieldUnitDTO could be removed.

#12 - 03/29/2021 10:46 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Kohlbecker

| removed that the derivatives are added to the fieldUnitDto in loadFieldUnitDto().

#13 - 04/13/2021 04:23 PM - Andreas Kohlbecker
- Status changed from Feedback to Resolved

- % Done changed from 0 to 50

after the 6d3c3fa9 which is rather related to listRootUnitDTOsByAssociatedTaxon() the web services should no longer include duplicate derivatives

#14 - 04/13/2021 04:31 PM - Andreas Kohlbecker
- Status changed from Resolved to Closed

- % Done changed from 50 to 100
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/3309605f00416edbed63485150dfad6eb8e7092f
can be closed now
